﻿// ECMAScript 5 strict mode
"use strict";

assert2(cr, "cr namespace not created");
assert2(cr.plugins_, "cr.plugins_ not created");

/////////////////////////////////////
// Plugin class
cr.plugins_.ARGV = function(runtime)
{
	this.runtime = runtime;
};

(function ()
{
	var pluginProto = cr.plugins_.ARGV.prototype;
		
	/////////////////////////////////////
	// Object type class
	pluginProto.Type = function(plugin){this.plugin = plugin; this.runtime = plugin.runtime;};

	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function(){};
	pluginProto.Instance = function(type){this.type = type;this.runtime = type.runtime;};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		
		this.dataurl = '';
		if(!this.runtime.isNodeWebkit) return;


		this.gui = require('nw.gui');
		this.win = this.gui['Window']['get'](window);
		this.argv = this.gui['App']['argv'];
		this.string = this.argv.join(' ');
		this.obj = {
			"c2array":true,
			"size":[this.argv.length,1,1], 
			"data":[]
		};

		this['args'] = [];
		var self = this;
		this.argv.forEach(function(i){
			self.obj["data"].push([[i]]); 
			self['args'].push(i);
		});

 		this.json = JSON.stringify(this.obj);
	};

	instanceProto.onDestroy = function (){};
	instanceProto.saveToJSON = function (){return {};};
	instanceProto.loadFromJSON = function (o){};
	instanceProto.draw = function(ctx){};
	instanceProto.drawGL = function (glw){};
	/**BEGIN-PREVIEWONLY**/
	instanceProto.getDebuggerValues = function (propsections){propsections.push({"title": "My debugger section","properties": []});};
	instanceProto.onDebugValueEdited = function (header, name, value){};
	/**END-PREVIEWONLY**/

	//////////////////////////////////////
	// Conditions
	function Cnds() {};
	Cnds.prototype.isNW = function (myparam){return this.runtime.isNodeWebkit;};
	Cnds.prototype.hasArgument = function(arg){return (this.runtime.isNodeWebkit && this['args'].indexOf(arg) !== -1);}
	Cnds.prototype.onSnapshot = function(){return true;}


	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Exit = function(){
		if(this.runtime.isNodeWebkit) this.gui["App"]["quit"](true);
	};

	Acts.prototype.snapShot = function(){
		if(!this.runtime.isNodeWebkit) return;
		var self = this;
		this.win['capturePage'](function(d){
			self.dataurl = d;
			self.runtime.trigger(cr.plugins_.ARGV.prototype.cnds.onSnapshot, self);
		},'png');
	};

	pluginProto.acts = new Acts();

	function Exps() {};
	Exps.prototype.snapshotdata = function(ret){ret.set_string(this.dataurl);}
	Exps.prototype.argv = function (ret){ret.set_string(!this.runtime.isNodeWebkit ? '' : this.json);}; //as array
	Exps.prototype.args = function (ret){ret.set_string(!this.runtime.isNodeWebkit ? '' : this.string);}  //as string
	Exps.prototype.length = function(ret){ret.set_int(!this.runtime.isNodeWebkit ? 0 : this.obj.size[0]);}
	Exps.prototype.argAt = function(ret,ind){ret.set_string(!this.runtime.isNodeWebkit ? 0 : (this['args'][ind] ? this['args'][ind] : ""));}
	pluginProto.exps = new Exps();

}());